glibmm: Gio::MenuModel Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::MenuModel Class Reference

MenuModel - An abstract class representing the contents of a menu. More...

`#include <giomm/menumodel.h>`

Inheritance diagram for Gio::MenuModel:
[legend]

## Public Member Functions
virtual | ~MenuModel ()
GMenuModel* | gobj ()
| Provides access to the underlying C GObject. More...
const GMenuModel* | gobj () const
| Provides access to the underlying C GObject. More...
GMenuModel* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type)
| Queries the item at position item_index in model for the attribute specified by attribute. More...
const Glib::VariantBase | get_item_attribute (int item_index, MenuAttribute attribute, const Glib::VariantType& expected_type) const
| Queries the item at position item_index in model for the attribute specified by attribute. More...
Glib::RefPtr< MenuModel > | get_item_link (int item_index, MenuLink link)
| Queries the item at position item_index in model for the link specified by link. More...
Glib::RefPtr< const MenuModel > | get_item_link (int item_index, MenuLink link) const
| Queries the item at position item_index in model for the link specified by link. More...
bool | is_mutable () const
| Queries if model is mutable. More...
int | get_n_items () const
| Query the number of items in model. More...
Glib::RefPtr< MenuAttributeIter > | iterate_item_attributes (int item_index)
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< const MenuAttributeIter > | iterate_item_attributes (int item_index) const
| Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model. More...
Glib::RefPtr< MenuLinkIter > | iterate_item_links (int item_index)
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
Glib::RefPtr< const MenuLinkIter > | iterate_item_links (int item_index) const
| Creates a MenuLinkIter to iterate over the links of the item at position item_index in model. More...
void | items_changed (int position, int removed, int added)
| Requests emission of the MenuModel::signal_items_changed() signal on model. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| MenuModel ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::MenuModel > | wrap (GMenuModel* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

MenuModel - An abstract class representing the contents of a menu.

MenuModel represents the contents of a menu – an ordered list of menu items. The items are associated with actions, which can be activated through them. Items can be grouped in sections, and may have submenus associated with them. Both items and sections usually have some representation data, such as labels or icons. The type of the associated action (ie whether it is stateful, and what kind of state it has) can influence the representation of the item.

The conceptual model of menus in MenuModel is hierarchical: sections and submenus are again represented by MenuModels. Menus themselves do not define their own roles. Rather, the role of a particular MenuModel is defined by the item that references it (or, in the case of the 'root' menu, is defined by the context in which it is used).

The motivation for this abstract model of application controls is that modern user interfaces tend to make these controls available outside the application. Examples include global menus, jumplists, dash boards, etc. To support such uses, it is necessary to 'export' information about actions and their representation in menus, which is exactly what Gio::DBus::Connection::export_action_group() and the Gio::DBus::Connection::export_menu_model() do for ActionGroup and MenuModel. The client-side counterparts to make use of the exported information are Gio::DBus::ActionGroup and Gio::DBus::MenuModel.

The API of MenuModel is very generic, with iterators for the attributes and links of an item, see iterate_item_attributes() and iterate_item_links(). The 'standard' attributes and link types have predefined names: Gio::MENU_ATTRIBUTE_LABEL, Gio::MENU_ATTRIBUTE_ACTION, Gio::MENU_ATTRIBUTE_TARGET, Gio::MENU_LINK_SECTION and Gio::MENU_LINK_SUBMENU.

Items in a MenuModel represent active controls if they refer to an action that can get activated when the user interacts with the menu item. The reference to the action is encoded by the string id in the Gio::MENU_ATTRIBUTE_ACTION attribute. An action id uniquely identifies an action in an action group. Which action group(s) provide actions depends on the context in which the menu model is used. E.g. when the model is exported as the application menu of a Gtk::Application, actions can be application-wide or window-specific (and thus come from two different action groups). By convention, the application-wide actions have names that start with "app.", while the names of window-specific actions start with "win.".

While a wide variety of stateful actions is possible, the following is the minimum that is expected to be supported by all users of exported menu information:

- an action with no parameter type and no state
- an action with no parameter type and boolean state
- an action with string parameter type and string state

Stateless. A stateless action typically corresponds to an ordinary menu item. Selecting such a menu item will activate the action (with no parameter).

Boolean State. An action with a boolean state will most typically be used with a "toggle" or "switch" menu item. The state can be set directly, but activating the action (with no parameter) results in the state being toggled. Selecting a toggle menu item will activate the action. The menu item should be rendered as "checked" when the state is true.

String Parameter and State. Actions with string parameters and state will most typically be used to represent an enumerated choice over the items available for a group of radio menu items. Activating the action with a string parameter is equivalent to setting that parameter as the state. Radio menu items, in addition to being associated with the action, will have a target value. Selecting that menu item will result in activation of the action with the target value as the parameter. The menu item should be rendered as "selected" when the state of the action is equal to the target value of the menu item.

See the C API docs for a graphical example.

Since glibmm 2.32:

## Constructor & Destructor Documentation

virtual Gio::MenuModel::~MenuModel | ( |  | ) |
| virtual

Reimplemented in Gio::DBus::MenuModel.

Gio::MenuModel::MenuModel | ( |  | ) |
| protected

## Member Function Documentation

Glib::VariantBase Gio::MenuModel::get_item_attribute | ( | int | item_index,
|  | MenuAttribute | attribute,
|  | const Glib::VariantType& | expected_type
| ) |  |

Queries the item at position item_index in model for the attribute specified by attribute.

If expected_type is non-`0` then it specifies the expected type of the attribute. If it is `0` then any type will be accepted.

If the attribute exists and matches expected_type (or if the expected type is unspecified) then the value is returned.

If the attribute does not exist, or does not match the expected type then `0` is returned.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.
  attribute | The attribute to query.
  expected_type | The expected type of the attribute, or `0`.

Returns
  The value of the attribute.

const Glib::VariantBase Gio::MenuModel::get_item_attribute | ( | int | item_index,
|  | MenuAttribute | attribute,
|  | const Glib::VariantType& | expected_type
| ) |  | const

Queries the item at position item_index in model for the attribute specified by attribute.

If expected_type is non-`0` then it specifies the expected type of the attribute. If it is `0` then any type will be accepted.

If the attribute exists and matches expected_type (or if the expected type is unspecified) then the value is returned.

If the attribute does not exist, or does not match the expected type then `0` is returned.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.
  attribute | The attribute to query.
  expected_type | The expected type of the attribute, or `0`.

Returns
  The value of the attribute.

Glib::RefPtr<MenuModel> Gio::MenuModel::get_item_link | ( | int | item_index,
|  | MenuLink | link
| ) |  |

Queries the item at position item_index in model for the link specified by link.

If the link exists, the linked MenuModel is returned. If the link does not exist, `0` is returned.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.
  link | The link to query.

Returns
  The linked MenuModel, or `0`.

Glib::RefPtr<const MenuModel> Gio::MenuModel::get_item_link | ( | int | item_index,
|  | MenuLink | link
| ) |  | const

Queries the item at position item_index in model for the link specified by link.

If the link exists, the linked MenuModel is returned. If the link does not exist, `0` is returned.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.
  link | The link to query.

Returns
  The linked MenuModel, or `0`.

int Gio::MenuModel::get_n_items | ( |  | ) | const

Query the number of items in model.

Since glibmm 2.32:

Returns
  The number of items.

static GType Gio::MenuModel::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GMenuModel* Gio::MenuModel::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GMenuModel* Gio::MenuModel::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GMenuModel* Gio::MenuModel::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::MenuModel::is_mutable | ( |  | ) | const

Queries if model is mutable.

An immutable MenuModel will never emit the MenuModel::signal_items_changed() signal. Consumers of the model may make optimisations accordingly.

Since glibmm 2.32:

Returns
  `true` if the model is mutable (ie: "items-changed" may be emitted).

void Gio::MenuModel::items_changed | ( | int | position,
|  | int | removed,
|  | int | added
| ) |  |

Requests emission of the MenuModel::signal_items_changed() signal on model.

This function should never be called except by MenuModel subclasses. Any other calls to this function will very likely lead to a violation of the interface of the model.

The implementation should update its internal representation of the menu before emitting the signal. The implementation should further expect to receive queries about the new state of the menu (and particularly added menu items) while signal handlers are running.

The implementation must dispatch this call directly from a mainloop entry and not in response to calls – particularly those from the MenuModel API. Said another way: the menu must not change while user code is running without returning to the mainloop.

Since glibmm 2.32:

Parameters

  position | The position of the change.
  removed | The number of items removed.
  added | The number of items added.

Glib::RefPtr<MenuAttributeIter> Gio::MenuModel::iterate_item_attributes | ( | int | item_index | ) |

Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model.

You must free the iterator with Glib::object_unref() when you are done.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.

Returns
  A new MenuAttributeIter.

Glib::RefPtr<const MenuAttributeIter> Gio::MenuModel::iterate_item_attributes | ( | int | item_index | ) | const

Creates a MenuAttributeIter to iterate over the attributes of the item at position item_index in model.

You must free the iterator with Glib::object_unref() when you are done.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.

Returns
  A new MenuAttributeIter.

Glib::RefPtr<MenuLinkIter> Gio::MenuModel::iterate_item_links | ( | int | item_index | ) |

Creates a MenuLinkIter to iterate over the links of the item at position item_index in model.

You must free the iterator with Glib::object_unref() when you are done.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.

Returns
  A new MenuLinkIter.

Glib::RefPtr<const MenuLinkIter> Gio::MenuModel::iterate_item_links | ( | int | item_index | ) | const

Creates a MenuLinkIter to iterate over the links of the item at position item_index in model.

You must free the iterator with Glib::object_unref() when you are done.

Since glibmm 2.32:

Parameters

  item_index | The index of the item.

Returns
  A new MenuLinkIter.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::MenuModel > wrap | ( | GMenuModel * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.